3 ### Build a Debian package on an sbuild server.
5 ### (c) 2016 Mark Wooding
8 ###----- Licensing notice ---------------------------------------------------
10 ### This program is free software; you can redistribute it and/or modify
11 ### it under the terms of the GNU General Public License as published by
12 ### the Free Software Foundation; either version 2 of the License, or
13 ### (at your option) any later version.
15 ### This program is distributed in the hope that it will be useful,
16 ### but WITHOUT ANY WARRANTY; without even the implied warranty of
17 ### MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
18 ### GNU General Public License for more details.
20 ### You should have received a copy of the GNU General Public License
21 ### along with this program; if not, write to the Free Software Foundation,
22 ### Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
24 ###--------------------------------------------------------------------------
29 fail () { echo >&2 "$prog: $*"; exit 1; }
30 usage () { echo "usage: $prog [-ain] [-k KEYID] [-t TARGET] HOST"; }
31 fail_usage () { usage >&2; exit 1; }
33 ###--------------------------------------------------------------------------
38 while getopts "haik:nt:" opt; do
45 -h Show this help text.
46 -a Build only architecture-dependent packages.
47 -i Build only architecture-neutral packages.
48 -k KEYID Sign the result using KEYID.
49 -n Don't actually do the build.
50 -t TARGET Build in TARGET build environment.
54 a) buildopts="${buildopts+$buildopts }-a" ;;
55 i) buildopts="${buildopts+$buildopts }-i" ;;
57 n) buildopts="${buildopts+$buildopts }-n" noactp=t ;;
58 t) buildopts="${buildopts+$buildopts }-t$OPTARG" ;;
62 shift $(( $OPTIND - 1 ))
67 case $bogusp in t) fail_usage ;; esac
69 ###--------------------------------------------------------------------------
72 ## Figure out the package name and version number.
74 while read tag value; do
76 Source:) pkg=$value ;;
77 Version:) ver=$value ;;
80 $(dpkg-parsechangelog)
82 case ${pkg+t} in t) ;; *) fail "can't figure out the package name" ;; esac
83 case ${ver+t} in t) ;; *) fail "can't figure out the package version" ;; esac
85 ## Build a Debian source package. If we're signing, use `dpkg-buildpackage'
86 ## for this so that we get an uploadable `_source.changes' file out the end
88 case ${keyid+t},$noactp in
90 dpkg-buildpackage -S -k"$keyid"
94 dir=$(pwd); base=${dir##*/}
96 dpkg-source -b "$base"
100 [ -f "$dsc" ] || fail "where is my \`.dsc' file?"
102 builddir=$(ssh "$host" mdw-sbuild-server dir "$pkg/$ver")
103 dcmd rsync -a "$dsc" "$host:$builddir/"
104 set +e; ssh "$host" mdw-sbuild-server $buildopts build "$builddir"
106 rsync -a "$host:$builddir/" ./
107 case $rc in 0) ;; *) exit $rc ;; esac
108 case $?,${keyid+t},$noactp in
109 0,t,nil) debsign -k"$keyid" "${pkg}_${ver}_"*.changes ;;